//-----------AMA+(HLm)---------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 SlateBlue
#property indicator_color2 SlateBlue
#property indicator_color3 Gold
//--------------------------------------------------------------------
extern double hr=24;
extern double nF=2;
extern double nS=30;
extern int m=2;
extern bool Norm=true;
//------------------------------
double NH,NHp,SH,SNH,SmoH,Fst,Slt,amaH[],amaHi; 
double NL,NLp,SL,SNL,SmoL,amaL[],amaS[],amaLi;
int p,fs;
datetime ti;
//--------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,amaH);
   SetIndexBuffer(1,amaL);
   SetIndexBuffer(2,amaS);
   //----------------------
   Fst=2.0/(nF+1);
   Slt=2.0/(nS+1);
   SmoH=1.0;
   SmoL=1.0;
   p=hr*60/Period()+1;
   //----------------------
   return(0);
}
//--------------------------------------------------------------------
int start() 
{
  int cbi,IC=IndicatorCounted();
  if (IC>3) cbi=Bars-IC-1; else 
  {
    cbi=Bars-p-2; 
    amaH[cbi+1]=High[cbi+1]; amaHi=High[cbi];
    amaL[cbi+1]= Low[cbi+1]; amaLi=Low[cbi];
    NHp=0.0; for (int n=cbi+1; n<cbi+p; n++) NHp+=MathAbs(High[n]-High[n+1]);
    NLp=0.0; for (n=cbi+1; n<cbi+p; n++) NLp+=MathAbs(Low[n]-Low[n+1]);
    ti=Time[cbi];
  } 
  //--------------------------------
  for (int i=cbi; i>=0; i--) 
  {
    //-----------------------------------------------
    if (ti!=Time[i]) 
    {
      NLp+=MathAbs(Low[i+1]-Low[i+2])-MathAbs(Low[i+p]-Low[i+p+1]);
      NHp+=MathAbs(High[i+1]-High[i+2])-MathAbs(High[i+p]-High[i+p+1]);
    }
    ti=Time[i];
    //-----------------------------------------------
    if (fs==1) 
    {
      SH=MathAbs(High[i]-High[i+p]);
      NH=NHp+MathAbs(High[i]-High[i+1]); 
      if (NH==0) NH=0.0000001; 
      SNH=SH/NH; 
      SmoH=MathPow(SNH*(Fst-Slt)+Slt,m);
      if (Norm) amaHi=NormalizeDouble(amaH[i+1]+SmoH*(High[i]-amaH[i+1]),4);
      else amaHi=amaH[i+1]+SmoH*(High[i]-amaH[i+1]);
    }
    //-------------------------------------------------
    if (fs==2) 
    {
      SL=MathAbs(Low[i]-Low[i+p]);
      NL=NLp+MathAbs(Low[i]-Low[i+1]); 
      if (NL==0) NL=0.0000001; 
      SNL=SL/NL; 
      SmoL=MathPow(SNL*(Fst-Slt)+Slt,m);
      if (Norm) amaLi=NormalizeDouble(amaL[i+1]+SmoL*(Low[i]-amaL[i+1]),4);
      else amaLi=amaL[i+1]+SmoL*(Low[i]-amaL[i+1]);
    }
    //--------------------------------------------------
    if (High[i]>amaHi) {amaHi=High[i]; fs=2;} else
    if (Low[i] <amaLi) {amaLi= Low[i]; fs=1;}
    //--------------------------------------------------
    amaH[i]=amaHi;
    amaL[i]=amaLi;
    amaS[i]=(amaH[i]+amaL[i])/2;
  }   
  //-----------------------------
  return(0); 
}
//*********************************************************************************